// Code generated by winrt-go-gen. DO NOT EDIT.

//go:build windows

//nolint:all
package frames

import (
	"syscall"
	"unsafe"

	"github.com/go-ole/go-ole"
	"github.com/saltosystems/winrt-go/windows/foundation/collections"
	"github.com/saltosystems/winrt-go/windows/media/mediaproperties"
)

const SignatureMediaFrameFormat string = "rc(Windows.Media.Capture.Frames.MediaFrameFormat;{71902b4e-b279-4a97-a9db-bd5a2fb78f39})"

type MediaFrameFormat struct {
	ole.IUnknown
}

func (impl *MediaFrameFormat) GetMajorType() (string, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameFormat))
	defer itf.Release()
	v := (*iMediaFrameFormat)(unsafe.Pointer(itf))
	return v.GetMajorType()
}

func (impl *MediaFrameFormat) GetSubtype() (string, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameFormat))
	defer itf.Release()
	v := (*iMediaFrameFormat)(unsafe.Pointer(itf))
	return v.GetSubtype()
}

func (impl *MediaFrameFormat) GetFrameRate() (*mediaproperties.MediaRatio, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameFormat))
	defer itf.Release()
	v := (*iMediaFrameFormat)(unsafe.Pointer(itf))
	return v.GetFrameRate()
}

func (impl *MediaFrameFormat) GetProperties() (*collections.IMapView, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameFormat))
	defer itf.Release()
	v := (*iMediaFrameFormat)(unsafe.Pointer(itf))
	return v.GetProperties()
}

func (impl *MediaFrameFormat) GetVideoFormat() (*VideoMediaFrameFormat, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameFormat))
	defer itf.Release()
	v := (*iMediaFrameFormat)(unsafe.Pointer(itf))
	return v.GetVideoFormat()
}

func (impl *MediaFrameFormat) GetAudioEncodingProperties() (*mediaproperties.AudioEncodingProperties, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameFormat2))
	defer itf.Release()
	v := (*iMediaFrameFormat2)(unsafe.Pointer(itf))
	return v.GetAudioEncodingProperties()
}

const GUIDiMediaFrameFormat string = "71902b4e-b279-4a97-a9db-bd5a2fb78f39"
const SignatureiMediaFrameFormat string = "{71902b4e-b279-4a97-a9db-bd5a2fb78f39}"

type iMediaFrameFormat struct {
	ole.IInspectable
}

type iMediaFrameFormatVtbl struct {
	ole.IInspectableVtbl

	GetMajorType   uintptr
	GetSubtype     uintptr
	GetFrameRate   uintptr
	GetProperties  uintptr
	GetVideoFormat uintptr
}

func (v *iMediaFrameFormat) VTable() *iMediaFrameFormatVtbl {
	return (*iMediaFrameFormatVtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaFrameFormat) GetMajorType() (string, error) {
	var outHStr ole.HString
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetMajorType,
		uintptr(unsafe.Pointer(v)),        // this
		uintptr(unsafe.Pointer(&outHStr)), // out string
	)

	if hr != 0 {
		return "", ole.NewError(hr)
	}

	out := outHStr.String()
	ole.DeleteHString(outHStr)
	return out, nil
}

func (v *iMediaFrameFormat) GetSubtype() (string, error) {
	var outHStr ole.HString
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetSubtype,
		uintptr(unsafe.Pointer(v)),        // this
		uintptr(unsafe.Pointer(&outHStr)), // out string
	)

	if hr != 0 {
		return "", ole.NewError(hr)
	}

	out := outHStr.String()
	ole.DeleteHString(outHStr)
	return out, nil
}

func (v *iMediaFrameFormat) GetFrameRate() (*mediaproperties.MediaRatio, error) {
	var out *mediaproperties.MediaRatio
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetFrameRate,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out mediaproperties.MediaRatio
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaFrameFormat) GetProperties() (*collections.IMapView, error) {
	var out *collections.IMapView
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetProperties,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out collections.IMapView
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaFrameFormat) GetVideoFormat() (*VideoMediaFrameFormat, error) {
	var out *VideoMediaFrameFormat
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetVideoFormat,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out VideoMediaFrameFormat
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

const GUIDiMediaFrameFormat2 string = "63856340-5e87-4c10-86d1-6df097a6c6a8"
const SignatureiMediaFrameFormat2 string = "{63856340-5e87-4c10-86d1-6df097a6c6a8}"

type iMediaFrameFormat2 struct {
	ole.IInspectable
}

type iMediaFrameFormat2Vtbl struct {
	ole.IInspectableVtbl

	GetAudioEncodingProperties uintptr
}

func (v *iMediaFrameFormat2) VTable() *iMediaFrameFormat2Vtbl {
	return (*iMediaFrameFormat2Vtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaFrameFormat2) GetAudioEncodingProperties() (*mediaproperties.AudioEncodingProperties, error) {
	var out *mediaproperties.AudioEncodingProperties
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetAudioEncodingProperties,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out mediaproperties.AudioEncodingProperties
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}
