// Code generated by winrt-go-gen. DO NOT EDIT.

//go:build windows

//nolint:all
package frames

import (
	"syscall"
	"unsafe"

	"github.com/go-ole/go-ole"
	"github.com/saltosystems/winrt-go/windows/foundation"
	"github.com/saltosystems/winrt-go/windows/media/devices"
)

const SignatureMediaFrameSourceController string = "rc(Windows.Media.Capture.Frames.MediaFrameSourceController;{6d076635-316d-4b8f-b7b6-eeb04a8c6525})"

type MediaFrameSourceController struct {
	ole.IUnknown
}

func (impl *MediaFrameSourceController) GetPropertyAsync(propertyId string) (*foundation.IAsyncOperation, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameSourceController))
	defer itf.Release()
	v := (*iMediaFrameSourceController)(unsafe.Pointer(itf))
	return v.GetPropertyAsync(propertyId)
}

func (impl *MediaFrameSourceController) SetPropertyAsync(propertyId string, propertyValue unsafe.Pointer) (*foundation.IAsyncOperation, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameSourceController))
	defer itf.Release()
	v := (*iMediaFrameSourceController)(unsafe.Pointer(itf))
	return v.SetPropertyAsync(propertyId, propertyValue)
}

func (impl *MediaFrameSourceController) GetVideoDeviceController() (*devices.VideoDeviceController, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameSourceController))
	defer itf.Release()
	v := (*iMediaFrameSourceController)(unsafe.Pointer(itf))
	return v.GetVideoDeviceController()
}

func (impl *MediaFrameSourceController) GetPropertyByExtendedIdAsync(extendedPropertyIdSize uint32, extendedPropertyId []uint8, maxPropertyValueSize *foundation.IReference) (*foundation.IAsyncOperation, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameSourceController2))
	defer itf.Release()
	v := (*iMediaFrameSourceController2)(unsafe.Pointer(itf))
	return v.GetPropertyByExtendedIdAsync(extendedPropertyIdSize, extendedPropertyId, maxPropertyValueSize)
}

func (impl *MediaFrameSourceController) SetPropertyByExtendedIdAsync(extendedPropertyIdSize uint32, extendedPropertyId []uint8, propertyValueSize uint32, propertyValue []uint8) (*foundation.IAsyncOperation, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameSourceController2))
	defer itf.Release()
	v := (*iMediaFrameSourceController2)(unsafe.Pointer(itf))
	return v.SetPropertyByExtendedIdAsync(extendedPropertyIdSize, extendedPropertyId, propertyValueSize, propertyValue)
}

func (impl *MediaFrameSourceController) GetAudioDeviceController() (*devices.AudioDeviceController, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameSourceController3))
	defer itf.Release()
	v := (*iMediaFrameSourceController3)(unsafe.Pointer(itf))
	return v.GetAudioDeviceController()
}

const GUIDiMediaFrameSourceController string = "6d076635-316d-4b8f-b7b6-eeb04a8c6525"
const SignatureiMediaFrameSourceController string = "{6d076635-316d-4b8f-b7b6-eeb04a8c6525}"

type iMediaFrameSourceController struct {
	ole.IInspectable
}

type iMediaFrameSourceControllerVtbl struct {
	ole.IInspectableVtbl

	GetPropertyAsync         uintptr
	SetPropertyAsync         uintptr
	GetVideoDeviceController uintptr
}

func (v *iMediaFrameSourceController) VTable() *iMediaFrameSourceControllerVtbl {
	return (*iMediaFrameSourceControllerVtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaFrameSourceController) GetPropertyAsync(propertyId string) (*foundation.IAsyncOperation, error) {
	var out *foundation.IAsyncOperation
	propertyIdHStr, err := ole.NewHString(propertyId)
	if err != nil {
		return nil, err
	}
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetPropertyAsync,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(propertyIdHStr),       // in string
		uintptr(unsafe.Pointer(&out)), // out foundation.IAsyncOperation
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaFrameSourceController) SetPropertyAsync(propertyId string, propertyValue unsafe.Pointer) (*foundation.IAsyncOperation, error) {
	var out *foundation.IAsyncOperation
	propertyIdHStr, err := ole.NewHString(propertyId)
	if err != nil {
		return nil, err
	}
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetPropertyAsync,
		uintptr(unsafe.Pointer(v)),              // this
		uintptr(propertyIdHStr),                 // in string
		uintptr(unsafe.Pointer(&propertyValue)), // in unsafe.Pointer
		uintptr(unsafe.Pointer(&out)),           // out foundation.IAsyncOperation
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaFrameSourceController) GetVideoDeviceController() (*devices.VideoDeviceController, error) {
	var out *devices.VideoDeviceController
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetVideoDeviceController,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out devices.VideoDeviceController
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

const GUIDiMediaFrameSourceController2 string = "efc49fd4-fcf2-4a03-b4e4-ac9628739bee"
const SignatureiMediaFrameSourceController2 string = "{efc49fd4-fcf2-4a03-b4e4-ac9628739bee}"

type iMediaFrameSourceController2 struct {
	ole.IInspectable
}

type iMediaFrameSourceController2Vtbl struct {
	ole.IInspectableVtbl

	GetPropertyByExtendedIdAsync uintptr
	SetPropertyByExtendedIdAsync uintptr
}

func (v *iMediaFrameSourceController2) VTable() *iMediaFrameSourceController2Vtbl {
	return (*iMediaFrameSourceController2Vtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaFrameSourceController2) GetPropertyByExtendedIdAsync(extendedPropertyIdSize uint32, extendedPropertyId []uint8, maxPropertyValueSize *foundation.IReference) (*foundation.IAsyncOperation, error) {
	var out *foundation.IAsyncOperation
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetPropertyByExtendedIdAsync,
		uintptr(unsafe.Pointer(v)),                      // this
		uintptr(extendedPropertyIdSize),                 // in uint32
		uintptr(unsafe.Pointer(&extendedPropertyId[0])), // in uint8
		uintptr(unsafe.Pointer(maxPropertyValueSize)),   // in foundation.IReference
		uintptr(unsafe.Pointer(&out)),                   // out foundation.IAsyncOperation
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaFrameSourceController2) SetPropertyByExtendedIdAsync(extendedPropertyIdSize uint32, extendedPropertyId []uint8, propertyValueSize uint32, propertyValue []uint8) (*foundation.IAsyncOperation, error) {
	var out *foundation.IAsyncOperation
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetPropertyByExtendedIdAsync,
		uintptr(unsafe.Pointer(v)),                      // this
		uintptr(extendedPropertyIdSize),                 // in uint32
		uintptr(unsafe.Pointer(&extendedPropertyId[0])), // in uint8
		uintptr(propertyValueSize),                      // in uint32
		uintptr(unsafe.Pointer(&propertyValue[0])),      // in uint8
		uintptr(unsafe.Pointer(&out)),                   // out foundation.IAsyncOperation
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

const GUIDiMediaFrameSourceController3 string = "1f0cf815-2464-4651-b1e8-4a82dbdb54de"
const SignatureiMediaFrameSourceController3 string = "{1f0cf815-2464-4651-b1e8-4a82dbdb54de}"

type iMediaFrameSourceController3 struct {
	ole.IInspectable
}

type iMediaFrameSourceController3Vtbl struct {
	ole.IInspectableVtbl

	GetAudioDeviceController uintptr
}

func (v *iMediaFrameSourceController3) VTable() *iMediaFrameSourceController3Vtbl {
	return (*iMediaFrameSourceController3Vtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaFrameSourceController3) GetAudioDeviceController() (*devices.AudioDeviceController, error) {
	var out *devices.AudioDeviceController
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetAudioDeviceController,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out devices.AudioDeviceController
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}
