// Code generated by winrt-go-gen. DO NOT EDIT.

//go:build windows

//nolint:all
package frames

import (
	"syscall"
	"unsafe"

	"github.com/go-ole/go-ole"
	"github.com/saltosystems/winrt-go/windows/foundation"
	"github.com/saltosystems/winrt-go/windows/foundation/collections"
)

const SignatureMediaFrameSourceGroup string = "rc(Windows.Media.Capture.Frames.MediaFrameSourceGroup;{7f605b87-4832-4b5f-ae3d-412faab37d34})"

type MediaFrameSourceGroup struct {
	ole.IUnknown
}

func (impl *MediaFrameSourceGroup) GetId() (string, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameSourceGroup))
	defer itf.Release()
	v := (*iMediaFrameSourceGroup)(unsafe.Pointer(itf))
	return v.GetId()
}

func (impl *MediaFrameSourceGroup) GetDisplayName() (string, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameSourceGroup))
	defer itf.Release()
	v := (*iMediaFrameSourceGroup)(unsafe.Pointer(itf))
	return v.GetDisplayName()
}

func (impl *MediaFrameSourceGroup) GetSourceInfos() (*collections.IVectorView, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaFrameSourceGroup))
	defer itf.Release()
	v := (*iMediaFrameSourceGroup)(unsafe.Pointer(itf))
	return v.GetSourceInfos()
}

const GUIDiMediaFrameSourceGroup string = "7f605b87-4832-4b5f-ae3d-412faab37d34"
const SignatureiMediaFrameSourceGroup string = "{7f605b87-4832-4b5f-ae3d-412faab37d34}"

type iMediaFrameSourceGroup struct {
	ole.IInspectable
}

type iMediaFrameSourceGroupVtbl struct {
	ole.IInspectableVtbl

	GetId          uintptr
	GetDisplayName uintptr
	GetSourceInfos uintptr
}

func (v *iMediaFrameSourceGroup) VTable() *iMediaFrameSourceGroupVtbl {
	return (*iMediaFrameSourceGroupVtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaFrameSourceGroup) GetId() (string, error) {
	var outHStr ole.HString
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetId,
		uintptr(unsafe.Pointer(v)),        // this
		uintptr(unsafe.Pointer(&outHStr)), // out string
	)

	if hr != 0 {
		return "", ole.NewError(hr)
	}

	out := outHStr.String()
	ole.DeleteHString(outHStr)
	return out, nil
}

func (v *iMediaFrameSourceGroup) GetDisplayName() (string, error) {
	var outHStr ole.HString
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetDisplayName,
		uintptr(unsafe.Pointer(v)),        // this
		uintptr(unsafe.Pointer(&outHStr)), // out string
	)

	if hr != 0 {
		return "", ole.NewError(hr)
	}

	out := outHStr.String()
	ole.DeleteHString(outHStr)
	return out, nil
}

func (v *iMediaFrameSourceGroup) GetSourceInfos() (*collections.IVectorView, error) {
	var out *collections.IVectorView
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetSourceInfos,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out collections.IVectorView
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

const GUIDiMediaFrameSourceGroupStatics string = "1c48bfc5-436f-4508-94cf-d5d8b7326445"
const SignatureiMediaFrameSourceGroupStatics string = "{1c48bfc5-436f-4508-94cf-d5d8b7326445}"

type iMediaFrameSourceGroupStatics struct {
	ole.IInspectable
}

type iMediaFrameSourceGroupStaticsVtbl struct {
	ole.IInspectableVtbl

	MediaFrameSourceGroupFindAllAsync      uintptr
	MediaFrameSourceGroupFromIdAsync       uintptr
	MediaFrameSourceGroupGetDeviceSelector uintptr
}

func (v *iMediaFrameSourceGroupStatics) VTable() *iMediaFrameSourceGroupStaticsVtbl {
	return (*iMediaFrameSourceGroupStaticsVtbl)(unsafe.Pointer(v.RawVTable))
}

func MediaFrameSourceGroupFindAllAsync() (*foundation.IAsyncOperation, error) {
	inspectable, err := ole.RoGetActivationFactory("Windows.Media.Capture.Frames.MediaFrameSourceGroup", ole.NewGUID(GUIDiMediaFrameSourceGroupStatics))
	if err != nil {
		return nil, err
	}
	v := (*iMediaFrameSourceGroupStatics)(unsafe.Pointer(inspectable))

	var out *foundation.IAsyncOperation
	hr, _, _ := syscall.SyscallN(
		v.VTable().MediaFrameSourceGroupFindAllAsync,
		0,                             // this is a static func, so there's no this
		uintptr(unsafe.Pointer(&out)), // out foundation.IAsyncOperation
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func MediaFrameSourceGroupFromIdAsync(id string) (*foundation.IAsyncOperation, error) {
	inspectable, err := ole.RoGetActivationFactory("Windows.Media.Capture.Frames.MediaFrameSourceGroup", ole.NewGUID(GUIDiMediaFrameSourceGroupStatics))
	if err != nil {
		return nil, err
	}
	v := (*iMediaFrameSourceGroupStatics)(unsafe.Pointer(inspectable))

	var out *foundation.IAsyncOperation
	idHStr, err := ole.NewHString(id)
	if err != nil {
		return nil, err
	}
	hr, _, _ := syscall.SyscallN(
		v.VTable().MediaFrameSourceGroupFromIdAsync,
		0,                             // this is a static func, so there's no this
		uintptr(idHStr),               // in string
		uintptr(unsafe.Pointer(&out)), // out foundation.IAsyncOperation
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func MediaFrameSourceGroupGetDeviceSelector() (string, error) {
	inspectable, err := ole.RoGetActivationFactory("Windows.Media.Capture.Frames.MediaFrameSourceGroup", ole.NewGUID(GUIDiMediaFrameSourceGroupStatics))
	if err != nil {
		return "", err
	}
	v := (*iMediaFrameSourceGroupStatics)(unsafe.Pointer(inspectable))

	var outHStr ole.HString
	hr, _, _ := syscall.SyscallN(
		v.VTable().MediaFrameSourceGroupGetDeviceSelector,
		0,                                 // this is a static func, so there's no this
		uintptr(unsafe.Pointer(&outHStr)), // out string
	)

	if hr != 0 {
		return "", ole.NewError(hr)
	}

	out := outHStr.String()
	ole.DeleteHString(outHStr)
	return out, nil
}
