// Code generated by winrt-go-gen. DO NOT EDIT.

//go:build windows

//nolint:all
package playback

import (
	"syscall"
	"unsafe"

	"github.com/go-ole/go-ole"
	"github.com/saltosystems/winrt-go/windows/media"
	"github.com/saltosystems/winrt-go/windows/storage/streams"
)

const SignatureMediaItemDisplayProperties string = "rc(Windows.Media.Playback.MediaItemDisplayProperties;{1e3c1b48-7097-4384-a217-c1291dfa8c16})"

type MediaItemDisplayProperties struct {
	ole.IUnknown
}

func (impl *MediaItemDisplayProperties) GetType() (media.MediaPlaybackType, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaItemDisplayProperties))
	defer itf.Release()
	v := (*iMediaItemDisplayProperties)(unsafe.Pointer(itf))
	return v.GetType()
}

func (impl *MediaItemDisplayProperties) SetType(value media.MediaPlaybackType) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaItemDisplayProperties))
	defer itf.Release()
	v := (*iMediaItemDisplayProperties)(unsafe.Pointer(itf))
	return v.SetType(value)
}

func (impl *MediaItemDisplayProperties) GetMusicProperties() (*media.MusicDisplayProperties, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaItemDisplayProperties))
	defer itf.Release()
	v := (*iMediaItemDisplayProperties)(unsafe.Pointer(itf))
	return v.GetMusicProperties()
}

func (impl *MediaItemDisplayProperties) GetVideoProperties() (*media.VideoDisplayProperties, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaItemDisplayProperties))
	defer itf.Release()
	v := (*iMediaItemDisplayProperties)(unsafe.Pointer(itf))
	return v.GetVideoProperties()
}

func (impl *MediaItemDisplayProperties) GetThumbnail() (*streams.RandomAccessStreamReference, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaItemDisplayProperties))
	defer itf.Release()
	v := (*iMediaItemDisplayProperties)(unsafe.Pointer(itf))
	return v.GetThumbnail()
}

func (impl *MediaItemDisplayProperties) SetThumbnail(value *streams.RandomAccessStreamReference) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaItemDisplayProperties))
	defer itf.Release()
	v := (*iMediaItemDisplayProperties)(unsafe.Pointer(itf))
	return v.SetThumbnail(value)
}

func (impl *MediaItemDisplayProperties) ClearAll() error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaItemDisplayProperties))
	defer itf.Release()
	v := (*iMediaItemDisplayProperties)(unsafe.Pointer(itf))
	return v.ClearAll()
}

const GUIDiMediaItemDisplayProperties string = "1e3c1b48-7097-4384-a217-c1291dfa8c16"
const SignatureiMediaItemDisplayProperties string = "{1e3c1b48-7097-4384-a217-c1291dfa8c16}"

type iMediaItemDisplayProperties struct {
	ole.IInspectable
}

type iMediaItemDisplayPropertiesVtbl struct {
	ole.IInspectableVtbl

	GetType            uintptr
	SetType            uintptr
	GetMusicProperties uintptr
	GetVideoProperties uintptr
	GetThumbnail       uintptr
	SetThumbnail       uintptr
	ClearAll           uintptr
}

func (v *iMediaItemDisplayProperties) VTable() *iMediaItemDisplayPropertiesVtbl {
	return (*iMediaItemDisplayPropertiesVtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaItemDisplayProperties) GetType() (media.MediaPlaybackType, error) {
	var out media.MediaPlaybackType
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetType,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out media.MediaPlaybackType
	)

	if hr != 0 {
		return media.MediaPlaybackTypeUnknown, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaItemDisplayProperties) SetType(value media.MediaPlaybackType) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetType,
		uintptr(unsafe.Pointer(v)), // this
		uintptr(value),             // in media.MediaPlaybackType
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaItemDisplayProperties) GetMusicProperties() (*media.MusicDisplayProperties, error) {
	var out *media.MusicDisplayProperties
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetMusicProperties,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out media.MusicDisplayProperties
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaItemDisplayProperties) GetVideoProperties() (*media.VideoDisplayProperties, error) {
	var out *media.VideoDisplayProperties
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetVideoProperties,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out media.VideoDisplayProperties
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaItemDisplayProperties) GetThumbnail() (*streams.RandomAccessStreamReference, error) {
	var out *streams.RandomAccessStreamReference
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetThumbnail,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out streams.RandomAccessStreamReference
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaItemDisplayProperties) SetThumbnail(value *streams.RandomAccessStreamReference) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetThumbnail,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in streams.RandomAccessStreamReference
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaItemDisplayProperties) ClearAll() error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().ClearAll,
		uintptr(unsafe.Pointer(v)), // this
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}
