// Code generated by winrt-go-gen. DO NOT EDIT.

//go:build windows

//nolint:all
package playback

import (
	"math"
	"syscall"
	"unsafe"

	"github.com/go-ole/go-ole"
	"github.com/saltosystems/winrt-go/windows/foundation/numerics"
	"github.com/saltosystems/winrt-go/windows/media/mediaproperties"
)

const SignatureMediaPlaybackSphericalVideoProjection string = "rc(Windows.Media.Playback.MediaPlaybackSphericalVideoProjection;{d405b37c-6f0e-4661-b8ee-d487ba9752d5})"

type MediaPlaybackSphericalVideoProjection struct {
	ole.IUnknown
}

func (impl *MediaPlaybackSphericalVideoProjection) GetIsEnabled() (bool, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlaybackSphericalVideoProjection))
	defer itf.Release()
	v := (*iMediaPlaybackSphericalVideoProjection)(unsafe.Pointer(itf))
	return v.GetIsEnabled()
}

func (impl *MediaPlaybackSphericalVideoProjection) SetIsEnabled(value bool) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlaybackSphericalVideoProjection))
	defer itf.Release()
	v := (*iMediaPlaybackSphericalVideoProjection)(unsafe.Pointer(itf))
	return v.SetIsEnabled(value)
}

func (impl *MediaPlaybackSphericalVideoProjection) GetFrameFormat() (mediaproperties.SphericalVideoFrameFormat, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlaybackSphericalVideoProjection))
	defer itf.Release()
	v := (*iMediaPlaybackSphericalVideoProjection)(unsafe.Pointer(itf))
	return v.GetFrameFormat()
}

func (impl *MediaPlaybackSphericalVideoProjection) SetFrameFormat(value mediaproperties.SphericalVideoFrameFormat) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlaybackSphericalVideoProjection))
	defer itf.Release()
	v := (*iMediaPlaybackSphericalVideoProjection)(unsafe.Pointer(itf))
	return v.SetFrameFormat(value)
}

func (impl *MediaPlaybackSphericalVideoProjection) GetHorizontalFieldOfViewInDegrees() (float64, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlaybackSphericalVideoProjection))
	defer itf.Release()
	v := (*iMediaPlaybackSphericalVideoProjection)(unsafe.Pointer(itf))
	return v.GetHorizontalFieldOfViewInDegrees()
}

func (impl *MediaPlaybackSphericalVideoProjection) SetHorizontalFieldOfViewInDegrees(value float64) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlaybackSphericalVideoProjection))
	defer itf.Release()
	v := (*iMediaPlaybackSphericalVideoProjection)(unsafe.Pointer(itf))
	return v.SetHorizontalFieldOfViewInDegrees(value)
}

func (impl *MediaPlaybackSphericalVideoProjection) GetViewOrientation() (numerics.Quaternion, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlaybackSphericalVideoProjection))
	defer itf.Release()
	v := (*iMediaPlaybackSphericalVideoProjection)(unsafe.Pointer(itf))
	return v.GetViewOrientation()
}

func (impl *MediaPlaybackSphericalVideoProjection) SetViewOrientation(value numerics.Quaternion) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlaybackSphericalVideoProjection))
	defer itf.Release()
	v := (*iMediaPlaybackSphericalVideoProjection)(unsafe.Pointer(itf))
	return v.SetViewOrientation(value)
}

func (impl *MediaPlaybackSphericalVideoProjection) GetProjectionMode() (SphericalVideoProjectionMode, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlaybackSphericalVideoProjection))
	defer itf.Release()
	v := (*iMediaPlaybackSphericalVideoProjection)(unsafe.Pointer(itf))
	return v.GetProjectionMode()
}

func (impl *MediaPlaybackSphericalVideoProjection) SetProjectionMode(value SphericalVideoProjectionMode) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlaybackSphericalVideoProjection))
	defer itf.Release()
	v := (*iMediaPlaybackSphericalVideoProjection)(unsafe.Pointer(itf))
	return v.SetProjectionMode(value)
}

const GUIDiMediaPlaybackSphericalVideoProjection string = "d405b37c-6f0e-4661-b8ee-d487ba9752d5"
const SignatureiMediaPlaybackSphericalVideoProjection string = "{d405b37c-6f0e-4661-b8ee-d487ba9752d5}"

type iMediaPlaybackSphericalVideoProjection struct {
	ole.IInspectable
}

type iMediaPlaybackSphericalVideoProjectionVtbl struct {
	ole.IInspectableVtbl

	GetIsEnabled                      uintptr
	SetIsEnabled                      uintptr
	GetFrameFormat                    uintptr
	SetFrameFormat                    uintptr
	GetHorizontalFieldOfViewInDegrees uintptr
	SetHorizontalFieldOfViewInDegrees uintptr
	GetViewOrientation                uintptr
	SetViewOrientation                uintptr
	GetProjectionMode                 uintptr
	SetProjectionMode                 uintptr
}

func (v *iMediaPlaybackSphericalVideoProjection) VTable() *iMediaPlaybackSphericalVideoProjectionVtbl {
	return (*iMediaPlaybackSphericalVideoProjectionVtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaPlaybackSphericalVideoProjection) GetIsEnabled() (bool, error) {
	var out bool
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetIsEnabled,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out bool
	)

	if hr != 0 {
		return false, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlaybackSphericalVideoProjection) SetIsEnabled(value bool) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetIsEnabled,
		uintptr(unsafe.Pointer(v)),                // this
		uintptr(*(*byte)(unsafe.Pointer(&value))), // in bool
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlaybackSphericalVideoProjection) GetFrameFormat() (mediaproperties.SphericalVideoFrameFormat, error) {
	var out mediaproperties.SphericalVideoFrameFormat
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetFrameFormat,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out mediaproperties.SphericalVideoFrameFormat
	)

	if hr != 0 {
		return mediaproperties.SphericalVideoFrameFormatNone, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlaybackSphericalVideoProjection) SetFrameFormat(value mediaproperties.SphericalVideoFrameFormat) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetFrameFormat,
		uintptr(unsafe.Pointer(v)), // this
		uintptr(value),             // in mediaproperties.SphericalVideoFrameFormat
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlaybackSphericalVideoProjection) GetHorizontalFieldOfViewInDegrees() (float64, error) {
	var out float64
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetHorizontalFieldOfViewInDegrees,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out float64
	)

	if hr != 0 {
		return 0.0, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlaybackSphericalVideoProjection) SetHorizontalFieldOfViewInDegrees(value float64) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetHorizontalFieldOfViewInDegrees,
		uintptr(unsafe.Pointer(v)),       // this
		uintptr(math.Float64bits(value)), // in float64
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlaybackSphericalVideoProjection) GetViewOrientation() (numerics.Quaternion, error) {
	var out numerics.Quaternion
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetViewOrientation,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out numerics.Quaternion
	)

	if hr != 0 {
		return numerics.Quaternion{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlaybackSphericalVideoProjection) SetViewOrientation(value numerics.Quaternion) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetViewOrientation,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&value)), // in numerics.Quaternion
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlaybackSphericalVideoProjection) GetProjectionMode() (SphericalVideoProjectionMode, error) {
	var out SphericalVideoProjectionMode
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetProjectionMode,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out SphericalVideoProjectionMode
	)

	if hr != 0 {
		return SphericalVideoProjectionModeSpherical, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlaybackSphericalVideoProjection) SetProjectionMode(value SphericalVideoProjectionMode) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetProjectionMode,
		uintptr(unsafe.Pointer(v)), // this
		uintptr(value),             // in SphericalVideoProjectionMode
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}
