// Code generated by winrt-go-gen. DO NOT EDIT.

//go:build windows

//nolint:all
package playback

import (
	"math"
	"syscall"
	"unsafe"

	"github.com/go-ole/go-ole"
	"github.com/saltosystems/winrt-go/windows/devices/enumeration"
	"github.com/saltosystems/winrt-go/windows/foundation"
	"github.com/saltosystems/winrt-go/windows/foundation/collections"
	"github.com/saltosystems/winrt-go/windows/graphics/directx/direct3d11"
	"github.com/saltosystems/winrt-go/windows/media"
	"github.com/saltosystems/winrt-go/windows/media/audio"
	"github.com/saltosystems/winrt-go/windows/media/casting"
	"github.com/saltosystems/winrt-go/windows/media/core"
	"github.com/saltosystems/winrt-go/windows/media/protection"
	"github.com/saltosystems/winrt-go/windows/storage"
	"github.com/saltosystems/winrt-go/windows/storage/streams"
)

const SignatureMediaPlayer string = "rc(Windows.Media.Playback.MediaPlayer;{381a83cb-6fff-499b-8d64-2885dfc1249e})"

type MediaPlayer struct {
	ole.IUnknown
}

func NewMediaPlayer() (*MediaPlayer, error) {
	inspectable, err := ole.RoActivateInstance("Windows.Media.Playback.MediaPlayer")
	if err != nil {
		return nil, err
	}
	return (*MediaPlayer)(unsafe.Pointer(inspectable)), nil
}

func (impl *MediaPlayer) GetAutoPlay() (bool, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetAutoPlay()
}

func (impl *MediaPlayer) SetAutoPlay(value bool) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.SetAutoPlay(value)
}

func (impl *MediaPlayer) GetNaturalDuration() (foundation.TimeSpan, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetNaturalDuration()
}

func (impl *MediaPlayer) GetPosition() (foundation.TimeSpan, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetPosition()
}

func (impl *MediaPlayer) SetPosition(value foundation.TimeSpan) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.SetPosition(value)
}

func (impl *MediaPlayer) GetBufferingProgress() (float64, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetBufferingProgress()
}

func (impl *MediaPlayer) GetCurrentState() (MediaPlayerState, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetCurrentState()
}

func (impl *MediaPlayer) GetCanSeek() (bool, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetCanSeek()
}

func (impl *MediaPlayer) GetCanPause() (bool, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetCanPause()
}

func (impl *MediaPlayer) GetIsLoopingEnabled() (bool, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetIsLoopingEnabled()
}

func (impl *MediaPlayer) SetIsLoopingEnabled(value bool) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.SetIsLoopingEnabled(value)
}

func (impl *MediaPlayer) GetIsProtected() (bool, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetIsProtected()
}

func (impl *MediaPlayer) GetIsMuted() (bool, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetIsMuted()
}

func (impl *MediaPlayer) SetIsMuted(value bool) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.SetIsMuted(value)
}

func (impl *MediaPlayer) GetPlaybackRate() (float64, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetPlaybackRate()
}

func (impl *MediaPlayer) SetPlaybackRate(value float64) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.SetPlaybackRate(value)
}

func (impl *MediaPlayer) GetVolume() (float64, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetVolume()
}

func (impl *MediaPlayer) SetVolume(value float64) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.SetVolume(value)
}

func (impl *MediaPlayer) GetPlaybackMediaMarkers() (*PlaybackMediaMarkerSequence, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.GetPlaybackMediaMarkers()
}

func (impl *MediaPlayer) AddMediaOpened(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.AddMediaOpened(value)
}

func (impl *MediaPlayer) RemoveMediaOpened(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.RemoveMediaOpened(token)
}

func (impl *MediaPlayer) AddMediaEnded(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.AddMediaEnded(value)
}

func (impl *MediaPlayer) RemoveMediaEnded(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.RemoveMediaEnded(token)
}

func (impl *MediaPlayer) AddMediaFailed(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.AddMediaFailed(value)
}

func (impl *MediaPlayer) RemoveMediaFailed(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.RemoveMediaFailed(token)
}

func (impl *MediaPlayer) AddCurrentStateChanged(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.AddCurrentStateChanged(value)
}

func (impl *MediaPlayer) RemoveCurrentStateChanged(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.RemoveCurrentStateChanged(token)
}

func (impl *MediaPlayer) AddPlaybackMediaMarkerReached(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.AddPlaybackMediaMarkerReached(value)
}

func (impl *MediaPlayer) RemovePlaybackMediaMarkerReached(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.RemovePlaybackMediaMarkerReached(token)
}

func (impl *MediaPlayer) AddMediaPlayerRateChanged(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.AddMediaPlayerRateChanged(value)
}

func (impl *MediaPlayer) RemoveMediaPlayerRateChanged(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.RemoveMediaPlayerRateChanged(token)
}

func (impl *MediaPlayer) AddVolumeChanged(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.AddVolumeChanged(value)
}

func (impl *MediaPlayer) RemoveVolumeChanged(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.RemoveVolumeChanged(token)
}

func (impl *MediaPlayer) AddSeekCompleted(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.AddSeekCompleted(value)
}

func (impl *MediaPlayer) RemoveSeekCompleted(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.RemoveSeekCompleted(token)
}

func (impl *MediaPlayer) AddBufferingStarted(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.AddBufferingStarted(value)
}

func (impl *MediaPlayer) RemoveBufferingStarted(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.RemoveBufferingStarted(token)
}

func (impl *MediaPlayer) AddBufferingEnded(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.AddBufferingEnded(value)
}

func (impl *MediaPlayer) RemoveBufferingEnded(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.RemoveBufferingEnded(token)
}

func (impl *MediaPlayer) Play() error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.Play()
}

func (impl *MediaPlayer) Pause() error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.Pause()
}

func (impl *MediaPlayer) SetUriSource(value *foundation.Uri) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer))
	defer itf.Release()
	v := (*iMediaPlayer)(unsafe.Pointer(itf))
	return v.SetUriSource(value)
}

func (impl *MediaPlayer) GetProtectionManager() (*protection.MediaProtectionManager, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayerSource))
	defer itf.Release()
	v := (*iMediaPlayerSource)(unsafe.Pointer(itf))
	return v.GetProtectionManager()
}

func (impl *MediaPlayer) SetProtectionManager(value *protection.MediaProtectionManager) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayerSource))
	defer itf.Release()
	v := (*iMediaPlayerSource)(unsafe.Pointer(itf))
	return v.SetProtectionManager(value)
}

func (impl *MediaPlayer) SetFileSource(file *storage.IStorageFile) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayerSource))
	defer itf.Release()
	v := (*iMediaPlayerSource)(unsafe.Pointer(itf))
	return v.SetFileSource(file)
}

func (impl *MediaPlayer) SetStreamSource(stream *streams.IRandomAccessStream) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayerSource))
	defer itf.Release()
	v := (*iMediaPlayerSource)(unsafe.Pointer(itf))
	return v.SetStreamSource(stream)
}

func (impl *MediaPlayer) SetMediaSource(source *core.IMediaSource) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayerSource))
	defer itf.Release()
	v := (*iMediaPlayerSource)(unsafe.Pointer(itf))
	return v.SetMediaSource(source)
}

func (impl *MediaPlayer) GetSource() (*IMediaPlaybackSource, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayerSource2))
	defer itf.Release()
	v := (*iMediaPlayerSource2)(unsafe.Pointer(itf))
	return v.GetSource()
}

func (impl *MediaPlayer) SetSource(value *IMediaPlaybackSource) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayerSource2))
	defer itf.Release()
	v := (*iMediaPlayerSource2)(unsafe.Pointer(itf))
	return v.SetSource(value)
}

func (impl *MediaPlayer) GetSystemMediaTransportControls() (*media.SystemMediaTransportControls, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer2))
	defer itf.Release()
	v := (*iMediaPlayer2)(unsafe.Pointer(itf))
	return v.GetSystemMediaTransportControls()
}

func (impl *MediaPlayer) GetAudioCategory() (MediaPlayerAudioCategory, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer2))
	defer itf.Release()
	v := (*iMediaPlayer2)(unsafe.Pointer(itf))
	return v.GetAudioCategory()
}

func (impl *MediaPlayer) SetAudioCategory(value MediaPlayerAudioCategory) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer2))
	defer itf.Release()
	v := (*iMediaPlayer2)(unsafe.Pointer(itf))
	return v.SetAudioCategory(value)
}

func (impl *MediaPlayer) GetAudioDeviceType() (MediaPlayerAudioDeviceType, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer2))
	defer itf.Release()
	v := (*iMediaPlayer2)(unsafe.Pointer(itf))
	return v.GetAudioDeviceType()
}

func (impl *MediaPlayer) SetAudioDeviceType(value MediaPlayerAudioDeviceType) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer2))
	defer itf.Release()
	v := (*iMediaPlayer2)(unsafe.Pointer(itf))
	return v.SetAudioDeviceType(value)
}

func (impl *MediaPlayer) AddAudioEffectWithSettings(activatableClassId string, effectOptional bool, configuration *collections.IPropertySet) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayerEffects))
	defer itf.Release()
	v := (*iMediaPlayerEffects)(unsafe.Pointer(itf))
	return v.AddAudioEffectWithSettings(activatableClassId, effectOptional, configuration)
}

func (impl *MediaPlayer) RemoveAllEffects() error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayerEffects))
	defer itf.Release()
	v := (*iMediaPlayerEffects)(unsafe.Pointer(itf))
	return v.RemoveAllEffects()
}

func (impl *MediaPlayer) Close() error {
	itf := impl.MustQueryInterface(ole.NewGUID(foundation.GUIDIClosable))
	defer itf.Release()
	v := (*foundation.IClosable)(unsafe.Pointer(itf))
	return v.Close()
}

func (impl *MediaPlayer) AddIsMutedChanged(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.AddIsMutedChanged(value)
}

func (impl *MediaPlayer) RemoveIsMutedChanged(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.RemoveIsMutedChanged(token)
}

func (impl *MediaPlayer) AddSourceChanged(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.AddSourceChanged(value)
}

func (impl *MediaPlayer) RemoveSourceChanged(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.RemoveSourceChanged(token)
}

func (impl *MediaPlayer) GetAudioBalance() (float64, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.GetAudioBalance()
}

func (impl *MediaPlayer) SetAudioBalance(value float64) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.SetAudioBalance(value)
}

func (impl *MediaPlayer) GetRealTimePlayback() (bool, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.GetRealTimePlayback()
}

func (impl *MediaPlayer) SetRealTimePlayback(value bool) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.SetRealTimePlayback(value)
}

func (impl *MediaPlayer) GetStereoscopicVideoRenderMode() (StereoscopicVideoRenderMode, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.GetStereoscopicVideoRenderMode()
}

func (impl *MediaPlayer) SetStereoscopicVideoRenderMode(value StereoscopicVideoRenderMode) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.SetStereoscopicVideoRenderMode(value)
}

func (impl *MediaPlayer) GetBreakManager() (*MediaBreakManager, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.GetBreakManager()
}

func (impl *MediaPlayer) GetCommandManager() (*MediaPlaybackCommandManager, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.GetCommandManager()
}

func (impl *MediaPlayer) GetAudioDevice() (*enumeration.DeviceInformation, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.GetAudioDevice()
}

func (impl *MediaPlayer) SetAudioDevice(value *enumeration.DeviceInformation) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.SetAudioDevice(value)
}

func (impl *MediaPlayer) GetTimelineController() (*media.MediaTimelineController, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.GetTimelineController()
}

func (impl *MediaPlayer) SetTimelineController(value *media.MediaTimelineController) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.SetTimelineController(value)
}

func (impl *MediaPlayer) GetTimelineControllerPositionOffset() (foundation.TimeSpan, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.GetTimelineControllerPositionOffset()
}

func (impl *MediaPlayer) SetTimelineControllerPositionOffset(value foundation.TimeSpan) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.SetTimelineControllerPositionOffset(value)
}

func (impl *MediaPlayer) GetPlaybackSession() (*MediaPlaybackSession, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.GetPlaybackSession()
}

func (impl *MediaPlayer) StepForwardOneFrame() error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.StepForwardOneFrame()
}

func (impl *MediaPlayer) StepBackwardOneFrame() error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.StepBackwardOneFrame()
}

func (impl *MediaPlayer) GetAsCastingSource() (*casting.CastingSource, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer3))
	defer itf.Release()
	v := (*iMediaPlayer3)(unsafe.Pointer(itf))
	return v.GetAsCastingSource()
}

func (impl *MediaPlayer) SetSurfaceSize(size foundation.Size) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer4))
	defer itf.Release()
	v := (*iMediaPlayer4)(unsafe.Pointer(itf))
	return v.SetSurfaceSize(size)
}

func (impl *MediaPlayer) AddVideoEffectWithSettings(activatableClassId string, effectOptional bool, effectConfiguration *collections.IPropertySet) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayerEffects2))
	defer itf.Release()
	v := (*iMediaPlayerEffects2)(unsafe.Pointer(itf))
	return v.AddVideoEffectWithSettings(activatableClassId, effectOptional, effectConfiguration)
}

func (impl *MediaPlayer) AddVideoFrameAvailable(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer5))
	defer itf.Release()
	v := (*iMediaPlayer5)(unsafe.Pointer(itf))
	return v.AddVideoFrameAvailable(value)
}

func (impl *MediaPlayer) RemoveVideoFrameAvailable(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer5))
	defer itf.Release()
	v := (*iMediaPlayer5)(unsafe.Pointer(itf))
	return v.RemoveVideoFrameAvailable(token)
}

func (impl *MediaPlayer) GetIsVideoFrameServerEnabled() (bool, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer5))
	defer itf.Release()
	v := (*iMediaPlayer5)(unsafe.Pointer(itf))
	return v.GetIsVideoFrameServerEnabled()
}

func (impl *MediaPlayer) SetIsVideoFrameServerEnabled(value bool) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer5))
	defer itf.Release()
	v := (*iMediaPlayer5)(unsafe.Pointer(itf))
	return v.SetIsVideoFrameServerEnabled(value)
}

func (impl *MediaPlayer) CopyFrameToVideoSurface(destination *direct3d11.IDirect3DSurface) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer5))
	defer itf.Release()
	v := (*iMediaPlayer5)(unsafe.Pointer(itf))
	return v.CopyFrameToVideoSurface(destination)
}

func (impl *MediaPlayer) CopyFrameToVideoSurfaceWithTargetRectangle(destination *direct3d11.IDirect3DSurface, targetRectangle foundation.Rect) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer5))
	defer itf.Release()
	v := (*iMediaPlayer5)(unsafe.Pointer(itf))
	return v.CopyFrameToVideoSurfaceWithTargetRectangle(destination, targetRectangle)
}

func (impl *MediaPlayer) CopyFrameToStereoscopicVideoSurfaces(destinationLeftEye *direct3d11.IDirect3DSurface, destinationRightEye *direct3d11.IDirect3DSurface) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer5))
	defer itf.Release()
	v := (*iMediaPlayer5)(unsafe.Pointer(itf))
	return v.CopyFrameToStereoscopicVideoSurfaces(destinationLeftEye, destinationRightEye)
}

func (impl *MediaPlayer) AddSubtitleFrameChanged(handler *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer6))
	defer itf.Release()
	v := (*iMediaPlayer6)(unsafe.Pointer(itf))
	return v.AddSubtitleFrameChanged(handler)
}

func (impl *MediaPlayer) RemoveSubtitleFrameChanged(token foundation.EventRegistrationToken) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer6))
	defer itf.Release()
	v := (*iMediaPlayer6)(unsafe.Pointer(itf))
	return v.RemoveSubtitleFrameChanged(token)
}

func (impl *MediaPlayer) RenderSubtitlesToSurface(destination *direct3d11.IDirect3DSurface) (bool, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer6))
	defer itf.Release()
	v := (*iMediaPlayer6)(unsafe.Pointer(itf))
	return v.RenderSubtitlesToSurface(destination)
}

func (impl *MediaPlayer) RenderSubtitlesToSurfaceWithTargetRectangle(destination *direct3d11.IDirect3DSurface, targetRectangle foundation.Rect) (bool, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer6))
	defer itf.Release()
	v := (*iMediaPlayer6)(unsafe.Pointer(itf))
	return v.RenderSubtitlesToSurfaceWithTargetRectangle(destination, targetRectangle)
}

func (impl *MediaPlayer) GetAudioStateMonitor() (*audio.AudioStateMonitor, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiMediaPlayer7))
	defer itf.Release()
	v := (*iMediaPlayer7)(unsafe.Pointer(itf))
	return v.GetAudioStateMonitor()
}

const GUIDiMediaPlayer string = "381a83cb-6fff-499b-8d64-2885dfc1249e"
const SignatureiMediaPlayer string = "{381a83cb-6fff-499b-8d64-2885dfc1249e}"

type iMediaPlayer struct {
	ole.IInspectable
}

type iMediaPlayerVtbl struct {
	ole.IInspectableVtbl

	GetAutoPlay                      uintptr
	SetAutoPlay                      uintptr
	GetNaturalDuration               uintptr
	GetPosition                      uintptr
	SetPosition                      uintptr
	GetBufferingProgress             uintptr
	GetCurrentState                  uintptr
	GetCanSeek                       uintptr
	GetCanPause                      uintptr
	GetIsLoopingEnabled              uintptr
	SetIsLoopingEnabled              uintptr
	GetIsProtected                   uintptr
	GetIsMuted                       uintptr
	SetIsMuted                       uintptr
	GetPlaybackRate                  uintptr
	SetPlaybackRate                  uintptr
	GetVolume                        uintptr
	SetVolume                        uintptr
	GetPlaybackMediaMarkers          uintptr
	AddMediaOpened                   uintptr
	RemoveMediaOpened                uintptr
	AddMediaEnded                    uintptr
	RemoveMediaEnded                 uintptr
	AddMediaFailed                   uintptr
	RemoveMediaFailed                uintptr
	AddCurrentStateChanged           uintptr
	RemoveCurrentStateChanged        uintptr
	AddPlaybackMediaMarkerReached    uintptr
	RemovePlaybackMediaMarkerReached uintptr
	AddMediaPlayerRateChanged        uintptr
	RemoveMediaPlayerRateChanged     uintptr
	AddVolumeChanged                 uintptr
	RemoveVolumeChanged              uintptr
	AddSeekCompleted                 uintptr
	RemoveSeekCompleted              uintptr
	AddBufferingStarted              uintptr
	RemoveBufferingStarted           uintptr
	AddBufferingEnded                uintptr
	RemoveBufferingEnded             uintptr
	Play                             uintptr
	Pause                            uintptr
	SetUriSource                     uintptr
}

func (v *iMediaPlayer) VTable() *iMediaPlayerVtbl {
	return (*iMediaPlayerVtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaPlayer) GetAutoPlay() (bool, error) {
	var out bool
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetAutoPlay,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out bool
	)

	if hr != 0 {
		return false, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) SetAutoPlay(value bool) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetAutoPlay,
		uintptr(unsafe.Pointer(v)),                // this
		uintptr(*(*byte)(unsafe.Pointer(&value))), // in bool
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) GetNaturalDuration() (foundation.TimeSpan, error) {
	var out foundation.TimeSpan
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetNaturalDuration,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out foundation.TimeSpan
	)

	if hr != 0 {
		return foundation.TimeSpan{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) GetPosition() (foundation.TimeSpan, error) {
	var out foundation.TimeSpan
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetPosition,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out foundation.TimeSpan
	)

	if hr != 0 {
		return foundation.TimeSpan{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) SetPosition(value foundation.TimeSpan) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetPosition,
		uintptr(unsafe.Pointer(v)), // this
		uintptr(value.Duration),    // in foundation.TimeSpan
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) GetBufferingProgress() (float64, error) {
	var out float64
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetBufferingProgress,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out float64
	)

	if hr != 0 {
		return 0.0, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) GetCurrentState() (MediaPlayerState, error) {
	var out MediaPlayerState
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetCurrentState,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out MediaPlayerState
	)

	if hr != 0 {
		return MediaPlayerStateClosed, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) GetCanSeek() (bool, error) {
	var out bool
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetCanSeek,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out bool
	)

	if hr != 0 {
		return false, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) GetCanPause() (bool, error) {
	var out bool
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetCanPause,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out bool
	)

	if hr != 0 {
		return false, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) GetIsLoopingEnabled() (bool, error) {
	var out bool
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetIsLoopingEnabled,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out bool
	)

	if hr != 0 {
		return false, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) SetIsLoopingEnabled(value bool) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetIsLoopingEnabled,
		uintptr(unsafe.Pointer(v)),                // this
		uintptr(*(*byte)(unsafe.Pointer(&value))), // in bool
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) GetIsProtected() (bool, error) {
	var out bool
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetIsProtected,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out bool
	)

	if hr != 0 {
		return false, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) GetIsMuted() (bool, error) {
	var out bool
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetIsMuted,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out bool
	)

	if hr != 0 {
		return false, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) SetIsMuted(value bool) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetIsMuted,
		uintptr(unsafe.Pointer(v)),                // this
		uintptr(*(*byte)(unsafe.Pointer(&value))), // in bool
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) GetPlaybackRate() (float64, error) {
	var out float64
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetPlaybackRate,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out float64
	)

	if hr != 0 {
		return 0.0, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) SetPlaybackRate(value float64) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetPlaybackRate,
		uintptr(unsafe.Pointer(v)),       // this
		uintptr(math.Float64bits(value)), // in float64
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) GetVolume() (float64, error) {
	var out float64
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetVolume,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out float64
	)

	if hr != 0 {
		return 0.0, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) SetVolume(value float64) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetVolume,
		uintptr(unsafe.Pointer(v)),       // this
		uintptr(math.Float64bits(value)), // in float64
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) GetPlaybackMediaMarkers() (*PlaybackMediaMarkerSequence, error) {
	var out *PlaybackMediaMarkerSequence
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetPlaybackMediaMarkers,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out PlaybackMediaMarkerSequence
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) AddMediaOpened(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddMediaOpened,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) RemoveMediaOpened(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveMediaOpened,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) AddMediaEnded(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddMediaEnded,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) RemoveMediaEnded(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveMediaEnded,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) AddMediaFailed(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddMediaFailed,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) RemoveMediaFailed(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveMediaFailed,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) AddCurrentStateChanged(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddCurrentStateChanged,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) RemoveCurrentStateChanged(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveCurrentStateChanged,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) AddPlaybackMediaMarkerReached(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddPlaybackMediaMarkerReached,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) RemovePlaybackMediaMarkerReached(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemovePlaybackMediaMarkerReached,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) AddMediaPlayerRateChanged(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddMediaPlayerRateChanged,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) RemoveMediaPlayerRateChanged(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveMediaPlayerRateChanged,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) AddVolumeChanged(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddVolumeChanged,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) RemoveVolumeChanged(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveVolumeChanged,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) AddSeekCompleted(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddSeekCompleted,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) RemoveSeekCompleted(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveSeekCompleted,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) AddBufferingStarted(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddBufferingStarted,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) RemoveBufferingStarted(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveBufferingStarted,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) AddBufferingEnded(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddBufferingEnded,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer) RemoveBufferingEnded(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveBufferingEnded,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) Play() error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().Play,
		uintptr(unsafe.Pointer(v)), // this
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) Pause() error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().Pause,
		uintptr(unsafe.Pointer(v)), // this
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer) SetUriSource(value *foundation.Uri) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetUriSource,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.Uri
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

const GUIDiMediaPlayerSource string = "bd4f8897-1423-4c3e-82c5-0fb1af94f715"
const SignatureiMediaPlayerSource string = "{bd4f8897-1423-4c3e-82c5-0fb1af94f715}"

type iMediaPlayerSource struct {
	ole.IInspectable
}

type iMediaPlayerSourceVtbl struct {
	ole.IInspectableVtbl

	GetProtectionManager uintptr
	SetProtectionManager uintptr
	SetFileSource        uintptr
	SetStreamSource      uintptr
	SetMediaSource       uintptr
}

func (v *iMediaPlayerSource) VTable() *iMediaPlayerSourceVtbl {
	return (*iMediaPlayerSourceVtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaPlayerSource) GetProtectionManager() (*protection.MediaProtectionManager, error) {
	var out *protection.MediaProtectionManager
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetProtectionManager,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out protection.MediaProtectionManager
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayerSource) SetProtectionManager(value *protection.MediaProtectionManager) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetProtectionManager,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in protection.MediaProtectionManager
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayerSource) SetFileSource(file *storage.IStorageFile) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetFileSource,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(file)), // in storage.IStorageFile
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayerSource) SetStreamSource(stream *streams.IRandomAccessStream) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetStreamSource,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(stream)), // in streams.IRandomAccessStream
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayerSource) SetMediaSource(source *core.IMediaSource) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetMediaSource,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(source)), // in core.IMediaSource
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

const GUIDiMediaPlayerSource2 string = "82449b9f-7322-4c0b-b03b-3e69a48260c5"
const SignatureiMediaPlayerSource2 string = "{82449b9f-7322-4c0b-b03b-3e69a48260c5}"

type iMediaPlayerSource2 struct {
	ole.IInspectable
}

type iMediaPlayerSource2Vtbl struct {
	ole.IInspectableVtbl

	GetSource uintptr
	SetSource uintptr
}

func (v *iMediaPlayerSource2) VTable() *iMediaPlayerSource2Vtbl {
	return (*iMediaPlayerSource2Vtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaPlayerSource2) GetSource() (*IMediaPlaybackSource, error) {
	var out *IMediaPlaybackSource
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetSource,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out IMediaPlaybackSource
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayerSource2) SetSource(value *IMediaPlaybackSource) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetSource,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in IMediaPlaybackSource
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

const GUIDiMediaPlayer2 string = "3c841218-2123-4fc5-9082-2f883f77bdf5"
const SignatureiMediaPlayer2 string = "{3c841218-2123-4fc5-9082-2f883f77bdf5}"

type iMediaPlayer2 struct {
	ole.IInspectable
}

type iMediaPlayer2Vtbl struct {
	ole.IInspectableVtbl

	GetSystemMediaTransportControls uintptr
	GetAudioCategory                uintptr
	SetAudioCategory                uintptr
	GetAudioDeviceType              uintptr
	SetAudioDeviceType              uintptr
}

func (v *iMediaPlayer2) VTable() *iMediaPlayer2Vtbl {
	return (*iMediaPlayer2Vtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaPlayer2) GetSystemMediaTransportControls() (*media.SystemMediaTransportControls, error) {
	var out *media.SystemMediaTransportControls
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetSystemMediaTransportControls,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out media.SystemMediaTransportControls
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer2) GetAudioCategory() (MediaPlayerAudioCategory, error) {
	var out MediaPlayerAudioCategory
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetAudioCategory,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out MediaPlayerAudioCategory
	)

	if hr != 0 {
		return MediaPlayerAudioCategoryOther, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer2) SetAudioCategory(value MediaPlayerAudioCategory) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetAudioCategory,
		uintptr(unsafe.Pointer(v)), // this
		uintptr(value),             // in MediaPlayerAudioCategory
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer2) GetAudioDeviceType() (MediaPlayerAudioDeviceType, error) {
	var out MediaPlayerAudioDeviceType
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetAudioDeviceType,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out MediaPlayerAudioDeviceType
	)

	if hr != 0 {
		return MediaPlayerAudioDeviceTypeConsole, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer2) SetAudioDeviceType(value MediaPlayerAudioDeviceType) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetAudioDeviceType,
		uintptr(unsafe.Pointer(v)), // this
		uintptr(value),             // in MediaPlayerAudioDeviceType
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

const GUIDiMediaPlayerEffects string = "85a1deda-cab6-4cc0-8be3-6035f4de2591"
const SignatureiMediaPlayerEffects string = "{85a1deda-cab6-4cc0-8be3-6035f4de2591}"

type iMediaPlayerEffects struct {
	ole.IInspectable
}

type iMediaPlayerEffectsVtbl struct {
	ole.IInspectableVtbl

	AddAudioEffectWithSettings uintptr
	RemoveAllEffects           uintptr
}

func (v *iMediaPlayerEffects) VTable() *iMediaPlayerEffectsVtbl {
	return (*iMediaPlayerEffectsVtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaPlayerEffects) AddAudioEffectWithSettings(activatableClassId string, effectOptional bool, configuration *collections.IPropertySet) error {
	activatableClassIdHStr, err := ole.NewHString(activatableClassId)
	if err != nil {
		return err
	}
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddAudioEffectWithSettings,
		uintptr(unsafe.Pointer(v)),                         // this
		uintptr(activatableClassIdHStr),                    // in string
		uintptr(*(*byte)(unsafe.Pointer(&effectOptional))), // in bool
		uintptr(unsafe.Pointer(configuration)),             // in collections.IPropertySet
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayerEffects) RemoveAllEffects() error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveAllEffects,
		uintptr(unsafe.Pointer(v)), // this
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

const GUIDiMediaPlayer3 string = "ee0660da-031b-4feb-bd9b-92e0a0a8d299"
const SignatureiMediaPlayer3 string = "{ee0660da-031b-4feb-bd9b-92e0a0a8d299}"

type iMediaPlayer3 struct {
	ole.IInspectable
}

type iMediaPlayer3Vtbl struct {
	ole.IInspectableVtbl

	AddIsMutedChanged                   uintptr
	RemoveIsMutedChanged                uintptr
	AddSourceChanged                    uintptr
	RemoveSourceChanged                 uintptr
	GetAudioBalance                     uintptr
	SetAudioBalance                     uintptr
	GetRealTimePlayback                 uintptr
	SetRealTimePlayback                 uintptr
	GetStereoscopicVideoRenderMode      uintptr
	SetStereoscopicVideoRenderMode      uintptr
	GetBreakManager                     uintptr
	GetCommandManager                   uintptr
	GetAudioDevice                      uintptr
	SetAudioDevice                      uintptr
	GetTimelineController               uintptr
	SetTimelineController               uintptr
	GetTimelineControllerPositionOffset uintptr
	SetTimelineControllerPositionOffset uintptr
	GetPlaybackSession                  uintptr
	StepForwardOneFrame                 uintptr
	StepBackwardOneFrame                uintptr
	GetAsCastingSource                  uintptr
}

func (v *iMediaPlayer3) VTable() *iMediaPlayer3Vtbl {
	return (*iMediaPlayer3Vtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaPlayer3) AddIsMutedChanged(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddIsMutedChanged,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer3) RemoveIsMutedChanged(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveIsMutedChanged,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer3) AddSourceChanged(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddSourceChanged,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer3) RemoveSourceChanged(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveSourceChanged,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer3) GetAudioBalance() (float64, error) {
	var out float64
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetAudioBalance,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out float64
	)

	if hr != 0 {
		return 0.0, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer3) SetAudioBalance(value float64) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetAudioBalance,
		uintptr(unsafe.Pointer(v)),       // this
		uintptr(math.Float64bits(value)), // in float64
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer3) GetRealTimePlayback() (bool, error) {
	var out bool
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetRealTimePlayback,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out bool
	)

	if hr != 0 {
		return false, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer3) SetRealTimePlayback(value bool) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetRealTimePlayback,
		uintptr(unsafe.Pointer(v)),                // this
		uintptr(*(*byte)(unsafe.Pointer(&value))), // in bool
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer3) GetStereoscopicVideoRenderMode() (StereoscopicVideoRenderMode, error) {
	var out StereoscopicVideoRenderMode
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetStereoscopicVideoRenderMode,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out StereoscopicVideoRenderMode
	)

	if hr != 0 {
		return StereoscopicVideoRenderModeMono, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer3) SetStereoscopicVideoRenderMode(value StereoscopicVideoRenderMode) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetStereoscopicVideoRenderMode,
		uintptr(unsafe.Pointer(v)), // this
		uintptr(value),             // in StereoscopicVideoRenderMode
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer3) GetBreakManager() (*MediaBreakManager, error) {
	var out *MediaBreakManager
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetBreakManager,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out MediaBreakManager
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer3) GetCommandManager() (*MediaPlaybackCommandManager, error) {
	var out *MediaPlaybackCommandManager
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetCommandManager,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out MediaPlaybackCommandManager
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer3) GetAudioDevice() (*enumeration.DeviceInformation, error) {
	var out *enumeration.DeviceInformation
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetAudioDevice,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out enumeration.DeviceInformation
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer3) SetAudioDevice(value *enumeration.DeviceInformation) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetAudioDevice,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in enumeration.DeviceInformation
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer3) GetTimelineController() (*media.MediaTimelineController, error) {
	var out *media.MediaTimelineController
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetTimelineController,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out media.MediaTimelineController
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer3) SetTimelineController(value *media.MediaTimelineController) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetTimelineController,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in media.MediaTimelineController
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer3) GetTimelineControllerPositionOffset() (foundation.TimeSpan, error) {
	var out foundation.TimeSpan
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetTimelineControllerPositionOffset,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out foundation.TimeSpan
	)

	if hr != 0 {
		return foundation.TimeSpan{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer3) SetTimelineControllerPositionOffset(value foundation.TimeSpan) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetTimelineControllerPositionOffset,
		uintptr(unsafe.Pointer(v)), // this
		uintptr(value.Duration),    // in foundation.TimeSpan
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer3) GetPlaybackSession() (*MediaPlaybackSession, error) {
	var out *MediaPlaybackSession
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetPlaybackSession,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out MediaPlaybackSession
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer3) StepForwardOneFrame() error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().StepForwardOneFrame,
		uintptr(unsafe.Pointer(v)), // this
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer3) StepBackwardOneFrame() error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().StepBackwardOneFrame,
		uintptr(unsafe.Pointer(v)), // this
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer3) GetAsCastingSource() (*casting.CastingSource, error) {
	var out *casting.CastingSource
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetAsCastingSource,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out casting.CastingSource
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

const GUIDiMediaPlayer4 string = "80035db0-7448-4770-afcf-2a57450914c5"
const SignatureiMediaPlayer4 string = "{80035db0-7448-4770-afcf-2a57450914c5}"

type iMediaPlayer4 struct {
	ole.IInspectable
}

type iMediaPlayer4Vtbl struct {
	ole.IInspectableVtbl

	SetSurfaceSize uintptr
	GetSurface     uintptr
}

func (v *iMediaPlayer4) VTable() *iMediaPlayer4Vtbl {
	return (*iMediaPlayer4Vtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaPlayer4) SetSurfaceSize(size foundation.Size) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetSurfaceSize,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(&size)), // in foundation.Size
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

const GUIDiMediaPlayerEffects2 string = "fa419a79-1bbe-46c5-ae1f-8ee69fb3c2c7"
const SignatureiMediaPlayerEffects2 string = "{fa419a79-1bbe-46c5-ae1f-8ee69fb3c2c7}"

type iMediaPlayerEffects2 struct {
	ole.IInspectable
}

type iMediaPlayerEffects2Vtbl struct {
	ole.IInspectableVtbl

	AddVideoEffectWithSettings uintptr
}

func (v *iMediaPlayerEffects2) VTable() *iMediaPlayerEffects2Vtbl {
	return (*iMediaPlayerEffects2Vtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaPlayerEffects2) AddVideoEffectWithSettings(activatableClassId string, effectOptional bool, effectConfiguration *collections.IPropertySet) error {
	activatableClassIdHStr, err := ole.NewHString(activatableClassId)
	if err != nil {
		return err
	}
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddVideoEffectWithSettings,
		uintptr(unsafe.Pointer(v)),                         // this
		uintptr(activatableClassIdHStr),                    // in string
		uintptr(*(*byte)(unsafe.Pointer(&effectOptional))), // in bool
		uintptr(unsafe.Pointer(effectConfiguration)),       // in collections.IPropertySet
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

const GUIDiMediaPlayer5 string = "cfe537fd-f86a-4446-bf4d-c8e792b7b4b3"
const SignatureiMediaPlayer5 string = "{cfe537fd-f86a-4446-bf4d-c8e792b7b4b3}"

type iMediaPlayer5 struct {
	ole.IInspectable
}

type iMediaPlayer5Vtbl struct {
	ole.IInspectableVtbl

	AddVideoFrameAvailable                     uintptr
	RemoveVideoFrameAvailable                  uintptr
	GetIsVideoFrameServerEnabled               uintptr
	SetIsVideoFrameServerEnabled               uintptr
	CopyFrameToVideoSurface                    uintptr
	CopyFrameToVideoSurfaceWithTargetRectangle uintptr
	CopyFrameToStereoscopicVideoSurfaces       uintptr
}

func (v *iMediaPlayer5) VTable() *iMediaPlayer5Vtbl {
	return (*iMediaPlayer5Vtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaPlayer5) AddVideoFrameAvailable(value *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddVideoFrameAvailable,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),  // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer5) RemoveVideoFrameAvailable(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveVideoFrameAvailable,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer5) GetIsVideoFrameServerEnabled() (bool, error) {
	var out bool
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetIsVideoFrameServerEnabled,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out bool
	)

	if hr != 0 {
		return false, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer5) SetIsVideoFrameServerEnabled(value bool) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetIsVideoFrameServerEnabled,
		uintptr(unsafe.Pointer(v)),                // this
		uintptr(*(*byte)(unsafe.Pointer(&value))), // in bool
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer5) CopyFrameToVideoSurface(destination *direct3d11.IDirect3DSurface) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().CopyFrameToVideoSurface,
		uintptr(unsafe.Pointer(v)),           // this
		uintptr(unsafe.Pointer(destination)), // in direct3d11.IDirect3DSurface
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer5) CopyFrameToVideoSurfaceWithTargetRectangle(destination *direct3d11.IDirect3DSurface, targetRectangle foundation.Rect) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().CopyFrameToVideoSurfaceWithTargetRectangle,
		uintptr(unsafe.Pointer(v)),                // this
		uintptr(unsafe.Pointer(destination)),      // in direct3d11.IDirect3DSurface
		uintptr(unsafe.Pointer(&targetRectangle)), // in foundation.Rect
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer5) CopyFrameToStereoscopicVideoSurfaces(destinationLeftEye *direct3d11.IDirect3DSurface, destinationRightEye *direct3d11.IDirect3DSurface) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().CopyFrameToStereoscopicVideoSurfaces,
		uintptr(unsafe.Pointer(v)),                   // this
		uintptr(unsafe.Pointer(destinationLeftEye)),  // in direct3d11.IDirect3DSurface
		uintptr(unsafe.Pointer(destinationRightEye)), // in direct3d11.IDirect3DSurface
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

const GUIDiMediaPlayer6 string = "e0caa086-ae65-414c-b010-8bc55f00e692"
const SignatureiMediaPlayer6 string = "{e0caa086-ae65-414c-b010-8bc55f00e692}"

type iMediaPlayer6 struct {
	ole.IInspectable
}

type iMediaPlayer6Vtbl struct {
	ole.IInspectableVtbl

	AddSubtitleFrameChanged                     uintptr
	RemoveSubtitleFrameChanged                  uintptr
	RenderSubtitlesToSurface                    uintptr
	RenderSubtitlesToSurfaceWithTargetRectangle uintptr
}

func (v *iMediaPlayer6) VTable() *iMediaPlayer6Vtbl {
	return (*iMediaPlayer6Vtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaPlayer6) AddSubtitleFrameChanged(handler *foundation.TypedEventHandler) (foundation.EventRegistrationToken, error) {
	var out foundation.EventRegistrationToken
	hr, _, _ := syscall.SyscallN(
		v.VTable().AddSubtitleFrameChanged,
		uintptr(unsafe.Pointer(v)),       // this
		uintptr(unsafe.Pointer(handler)), // in foundation.TypedEventHandler
		uintptr(unsafe.Pointer(&out)),    // out foundation.EventRegistrationToken
	)

	if hr != 0 {
		return foundation.EventRegistrationToken{}, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer6) RemoveSubtitleFrameChanged(token foundation.EventRegistrationToken) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().RemoveSubtitleFrameChanged,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(unsafe.Pointer(&token)), // in foundation.EventRegistrationToken
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iMediaPlayer6) RenderSubtitlesToSurface(destination *direct3d11.IDirect3DSurface) (bool, error) {
	var out bool
	hr, _, _ := syscall.SyscallN(
		v.VTable().RenderSubtitlesToSurface,
		uintptr(unsafe.Pointer(v)),           // this
		uintptr(unsafe.Pointer(destination)), // in direct3d11.IDirect3DSurface
		uintptr(unsafe.Pointer(&out)),        // out bool
	)

	if hr != 0 {
		return false, ole.NewError(hr)
	}

	return out, nil
}

func (v *iMediaPlayer6) RenderSubtitlesToSurfaceWithTargetRectangle(destination *direct3d11.IDirect3DSurface, targetRectangle foundation.Rect) (bool, error) {
	var out bool
	hr, _, _ := syscall.SyscallN(
		v.VTable().RenderSubtitlesToSurfaceWithTargetRectangle,
		uintptr(unsafe.Pointer(v)),                // this
		uintptr(unsafe.Pointer(destination)),      // in direct3d11.IDirect3DSurface
		uintptr(unsafe.Pointer(&targetRectangle)), // in foundation.Rect
		uintptr(unsafe.Pointer(&out)),             // out bool
	)

	if hr != 0 {
		return false, ole.NewError(hr)
	}

	return out, nil
}

const GUIDiMediaPlayer7 string = "5d1dc478-4500-4531-b3f4-777a71491f7f"
const SignatureiMediaPlayer7 string = "{5d1dc478-4500-4531-b3f4-777a71491f7f}"

type iMediaPlayer7 struct {
	ole.IInspectable
}

type iMediaPlayer7Vtbl struct {
	ole.IInspectableVtbl

	GetAudioStateMonitor uintptr
}

func (v *iMediaPlayer7) VTable() *iMediaPlayer7Vtbl {
	return (*iMediaPlayer7Vtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iMediaPlayer7) GetAudioStateMonitor() (*audio.AudioStateMonitor, error) {
	var out *audio.AudioStateMonitor
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetAudioStateMonitor,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out audio.AudioStateMonitor
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}
