// Code generated by winrt-go-gen. DO NOT EDIT.

//go:build windows

//nolint:all
package protection

import (
	"sync"
	"time"
	"unsafe"

	"github.com/go-ole/go-ole"
	"github.com/saltosystems/winrt-go/internal/delegate"
	"github.com/saltosystems/winrt-go/internal/kernel32"
)

const GUIDRebootNeededEventHandler string = "64e12a45-973b-4a3a-b260-91898a49a82c"
const SignatureRebootNeededEventHandler string = "delegate({64e12a45-973b-4a3a-b260-91898a49a82c})"

type RebootNeededEventHandler struct {
	ole.IUnknown
	sync.Mutex
	refs uint64
	IID  ole.GUID
}

type RebootNeededEventHandlerVtbl struct {
	ole.IUnknownVtbl
	Invoke uintptr
}

type RebootNeededEventHandlerCallback func(instance *RebootNeededEventHandler, sender *MediaProtectionManager)

var callbacksRebootNeededEventHandler = &rebootNeededEventHandlerCallbacks{
	mu:        &sync.Mutex{},
	callbacks: make(map[unsafe.Pointer]RebootNeededEventHandlerCallback),
}

var releaseChannelsRebootNeededEventHandler = &rebootNeededEventHandlerReleaseChannels{
	mu:    &sync.Mutex{},
	chans: make(map[unsafe.Pointer]chan struct{}),
}

func NewRebootNeededEventHandler(iid *ole.GUID, callback RebootNeededEventHandlerCallback) *RebootNeededEventHandler {
	// create type instance
	size := unsafe.Sizeof(*(*RebootNeededEventHandler)(nil))
	instPtr := kernel32.Malloc(size)
	inst := (*RebootNeededEventHandler)(instPtr)

	// get the callbacks for the VTable
	callbacks := delegate.RegisterCallbacks(instPtr, inst)

	// the VTable should also be allocated in the heap
	sizeVTable := unsafe.Sizeof(*(*RebootNeededEventHandlerVtbl)(nil))
	vTablePtr := kernel32.Malloc(sizeVTable)

	inst.RawVTable = (*interface{})(vTablePtr)

	vTable := (*RebootNeededEventHandlerVtbl)(vTablePtr)
	vTable.IUnknownVtbl = ole.IUnknownVtbl{
		QueryInterface: callbacks.QueryInterface,
		AddRef:         callbacks.AddRef,
		Release:        callbacks.Release,
	}
	vTable.Invoke = callbacks.Invoke

	// Initialize all properties: the malloc may contain garbage
	inst.IID = *iid // copy contents
	inst.Mutex = sync.Mutex{}
	inst.refs = 0

	callbacksRebootNeededEventHandler.add(unsafe.Pointer(inst), callback)

	// See the docs in the releaseChannelsRebootNeededEventHandler struct
	releaseChannelsRebootNeededEventHandler.acquire(unsafe.Pointer(inst))

	inst.addRef()
	return inst
}

func (r *RebootNeededEventHandler) GetIID() *ole.GUID {
	return &r.IID
}

// addRef increments the reference counter by one
func (r *RebootNeededEventHandler) addRef() uint64 {
	r.Lock()
	defer r.Unlock()
	r.refs++
	return r.refs
}

// removeRef decrements the reference counter by one. If it was already zero, it will just return zero.
func (r *RebootNeededEventHandler) removeRef() uint64 {
	r.Lock()
	defer r.Unlock()

	if r.refs > 0 {
		r.refs--
	}

	return r.refs
}

func (instance *RebootNeededEventHandler) Invoke(instancePtr, rawArgs0, rawArgs1, rawArgs2, rawArgs3, rawArgs4, rawArgs5, rawArgs6, rawArgs7, rawArgs8 unsafe.Pointer) uintptr {
	senderPtr := rawArgs0

	// See the quote above.
	sender := (*MediaProtectionManager)(senderPtr)
	if callback, ok := callbacksRebootNeededEventHandler.get(instancePtr); ok {
		callback(instance, sender)
	}
	return ole.S_OK
}

func (instance *RebootNeededEventHandler) AddRef() uint64 {
	return instance.addRef()
}

func (instance *RebootNeededEventHandler) Release() uint64 {
	rem := instance.removeRef()
	if rem == 0 {
		// We're done.
		instancePtr := unsafe.Pointer(instance)
		callbacksRebootNeededEventHandler.delete(instancePtr)

		// stop release channels used to avoid
		// https://github.com/golang/go/issues/55015
		releaseChannelsRebootNeededEventHandler.release(instancePtr)

		kernel32.Free(unsafe.Pointer(instance.RawVTable))
		kernel32.Free(instancePtr)
	}
	return rem
}

type rebootNeededEventHandlerCallbacks struct {
	mu        *sync.Mutex
	callbacks map[unsafe.Pointer]RebootNeededEventHandlerCallback
}

func (m *rebootNeededEventHandlerCallbacks) add(p unsafe.Pointer, v RebootNeededEventHandlerCallback) {
	m.mu.Lock()
	defer m.mu.Unlock()

	m.callbacks[p] = v
}

func (m *rebootNeededEventHandlerCallbacks) get(p unsafe.Pointer) (RebootNeededEventHandlerCallback, bool) {
	m.mu.Lock()
	defer m.mu.Unlock()

	v, ok := m.callbacks[p]
	return v, ok
}

func (m *rebootNeededEventHandlerCallbacks) delete(p unsafe.Pointer) {
	m.mu.Lock()
	defer m.mu.Unlock()

	delete(m.callbacks, p)
}

// typedEventHandlerReleaseChannels keeps a map with channels
// used to keep a goroutine alive during the lifecycle of this object.
// This is required to avoid causing a deadlock error.
// See this: https://github.com/golang/go/issues/55015
type rebootNeededEventHandlerReleaseChannels struct {
	mu    *sync.Mutex
	chans map[unsafe.Pointer]chan struct{}
}

func (m *rebootNeededEventHandlerReleaseChannels) acquire(p unsafe.Pointer) {
	m.mu.Lock()
	defer m.mu.Unlock()

	c := make(chan struct{})
	m.chans[p] = c

	go func() {
		// we need a timer to trick the go runtime into
		// thinking there's still something going on here
		// but we are only really interested in <-c
		t := time.NewTimer(time.Minute)
		for {
			select {
			case <-t.C:
				t.Reset(time.Minute)
			case <-c:
				t.Stop()
				return
			}
		}
	}()
}

func (m *rebootNeededEventHandlerReleaseChannels) release(p unsafe.Pointer) {
	m.mu.Lock()
	defer m.mu.Unlock()

	if c, ok := m.chans[p]; ok {
		close(c)
		delete(m.chans, p)
	}
}
