// Code generated by winrt-go-gen. DO NOT EDIT.

//go:build windows

//nolint:all
package protection

import (
	"sync"
	"time"
	"unsafe"

	"github.com/go-ole/go-ole"
	"github.com/saltosystems/winrt-go/internal/delegate"
	"github.com/saltosystems/winrt-go/internal/kernel32"
)

const GUIDServiceRequestedEventHandler string = "d2d690ba-cac9-48e1-95c0-d38495a84055"
const SignatureServiceRequestedEventHandler string = "delegate({d2d690ba-cac9-48e1-95c0-d38495a84055})"

type ServiceRequestedEventHandler struct {
	ole.IUnknown
	sync.Mutex
	refs uint64
	IID  ole.GUID
}

type ServiceRequestedEventHandlerVtbl struct {
	ole.IUnknownVtbl
	Invoke uintptr
}

type ServiceRequestedEventHandlerCallback func(instance *ServiceRequestedEventHandler, sender *MediaProtectionManager, e *ServiceRequestedEventArgs)

var callbacksServiceRequestedEventHandler = &serviceRequestedEventHandlerCallbacks{
	mu:        &sync.Mutex{},
	callbacks: make(map[unsafe.Pointer]ServiceRequestedEventHandlerCallback),
}

var releaseChannelsServiceRequestedEventHandler = &serviceRequestedEventHandlerReleaseChannels{
	mu:    &sync.Mutex{},
	chans: make(map[unsafe.Pointer]chan struct{}),
}

func NewServiceRequestedEventHandler(iid *ole.GUID, callback ServiceRequestedEventHandlerCallback) *ServiceRequestedEventHandler {
	// create type instance
	size := unsafe.Sizeof(*(*ServiceRequestedEventHandler)(nil))
	instPtr := kernel32.Malloc(size)
	inst := (*ServiceRequestedEventHandler)(instPtr)

	// get the callbacks for the VTable
	callbacks := delegate.RegisterCallbacks(instPtr, inst)

	// the VTable should also be allocated in the heap
	sizeVTable := unsafe.Sizeof(*(*ServiceRequestedEventHandlerVtbl)(nil))
	vTablePtr := kernel32.Malloc(sizeVTable)

	inst.RawVTable = (*interface{})(vTablePtr)

	vTable := (*ServiceRequestedEventHandlerVtbl)(vTablePtr)
	vTable.IUnknownVtbl = ole.IUnknownVtbl{
		QueryInterface: callbacks.QueryInterface,
		AddRef:         callbacks.AddRef,
		Release:        callbacks.Release,
	}
	vTable.Invoke = callbacks.Invoke

	// Initialize all properties: the malloc may contain garbage
	inst.IID = *iid // copy contents
	inst.Mutex = sync.Mutex{}
	inst.refs = 0

	callbacksServiceRequestedEventHandler.add(unsafe.Pointer(inst), callback)

	// See the docs in the releaseChannelsServiceRequestedEventHandler struct
	releaseChannelsServiceRequestedEventHandler.acquire(unsafe.Pointer(inst))

	inst.addRef()
	return inst
}

func (r *ServiceRequestedEventHandler) GetIID() *ole.GUID {
	return &r.IID
}

// addRef increments the reference counter by one
func (r *ServiceRequestedEventHandler) addRef() uint64 {
	r.Lock()
	defer r.Unlock()
	r.refs++
	return r.refs
}

// removeRef decrements the reference counter by one. If it was already zero, it will just return zero.
func (r *ServiceRequestedEventHandler) removeRef() uint64 {
	r.Lock()
	defer r.Unlock()

	if r.refs > 0 {
		r.refs--
	}

	return r.refs
}

func (instance *ServiceRequestedEventHandler) Invoke(instancePtr, rawArgs0, rawArgs1, rawArgs2, rawArgs3, rawArgs4, rawArgs5, rawArgs6, rawArgs7, rawArgs8 unsafe.Pointer) uintptr {
	senderPtr := rawArgs0
	ePtr := rawArgs1

	// See the quote above.
	sender := (*MediaProtectionManager)(senderPtr)
	e := (*ServiceRequestedEventArgs)(ePtr)
	if callback, ok := callbacksServiceRequestedEventHandler.get(instancePtr); ok {
		callback(instance, sender, e)
	}
	return ole.S_OK
}

func (instance *ServiceRequestedEventHandler) AddRef() uint64 {
	return instance.addRef()
}

func (instance *ServiceRequestedEventHandler) Release() uint64 {
	rem := instance.removeRef()
	if rem == 0 {
		// We're done.
		instancePtr := unsafe.Pointer(instance)
		callbacksServiceRequestedEventHandler.delete(instancePtr)

		// stop release channels used to avoid
		// https://github.com/golang/go/issues/55015
		releaseChannelsServiceRequestedEventHandler.release(instancePtr)

		kernel32.Free(unsafe.Pointer(instance.RawVTable))
		kernel32.Free(instancePtr)
	}
	return rem
}

type serviceRequestedEventHandlerCallbacks struct {
	mu        *sync.Mutex
	callbacks map[unsafe.Pointer]ServiceRequestedEventHandlerCallback
}

func (m *serviceRequestedEventHandlerCallbacks) add(p unsafe.Pointer, v ServiceRequestedEventHandlerCallback) {
	m.mu.Lock()
	defer m.mu.Unlock()

	m.callbacks[p] = v
}

func (m *serviceRequestedEventHandlerCallbacks) get(p unsafe.Pointer) (ServiceRequestedEventHandlerCallback, bool) {
	m.mu.Lock()
	defer m.mu.Unlock()

	v, ok := m.callbacks[p]
	return v, ok
}

func (m *serviceRequestedEventHandlerCallbacks) delete(p unsafe.Pointer) {
	m.mu.Lock()
	defer m.mu.Unlock()

	delete(m.callbacks, p)
}

// typedEventHandlerReleaseChannels keeps a map with channels
// used to keep a goroutine alive during the lifecycle of this object.
// This is required to avoid causing a deadlock error.
// See this: https://github.com/golang/go/issues/55015
type serviceRequestedEventHandlerReleaseChannels struct {
	mu    *sync.Mutex
	chans map[unsafe.Pointer]chan struct{}
}

func (m *serviceRequestedEventHandlerReleaseChannels) acquire(p unsafe.Pointer) {
	m.mu.Lock()
	defer m.mu.Unlock()

	c := make(chan struct{})
	m.chans[p] = c

	go func() {
		// we need a timer to trick the go runtime into
		// thinking there's still something going on here
		// but we are only really interested in <-c
		t := time.NewTimer(time.Minute)
		for {
			select {
			case <-t.C:
				t.Reset(time.Minute)
			case <-c:
				t.Stop()
				return
			}
		}
	}()
}

func (m *serviceRequestedEventHandlerReleaseChannels) release(p unsafe.Pointer) {
	m.mu.Lock()
	defer m.mu.Unlock()

	if c, ok := m.chans[p]; ok {
		close(c)
		delete(m.chans, p)
	}
}
