// Code generated by winrt-go-gen. DO NOT EDIT.

//go:build windows

//nolint:all
package media

import (
	"syscall"
	"unsafe"

	"github.com/go-ole/go-ole"
	"github.com/saltosystems/winrt-go/windows/foundation"
	"github.com/saltosystems/winrt-go/windows/storage"
	"github.com/saltosystems/winrt-go/windows/storage/streams"
)

const SignatureSystemMediaTransportControlsDisplayUpdater string = "rc(Windows.Media.SystemMediaTransportControlsDisplayUpdater;{8abbc53e-fa55-4ecf-ad8e-c984e5dd1550})"

type SystemMediaTransportControlsDisplayUpdater struct {
	ole.IUnknown
}

func (impl *SystemMediaTransportControlsDisplayUpdater) GetType() (MediaPlaybackType, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiSystemMediaTransportControlsDisplayUpdater))
	defer itf.Release()
	v := (*iSystemMediaTransportControlsDisplayUpdater)(unsafe.Pointer(itf))
	return v.GetType()
}

func (impl *SystemMediaTransportControlsDisplayUpdater) SetType(value MediaPlaybackType) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiSystemMediaTransportControlsDisplayUpdater))
	defer itf.Release()
	v := (*iSystemMediaTransportControlsDisplayUpdater)(unsafe.Pointer(itf))
	return v.SetType(value)
}

func (impl *SystemMediaTransportControlsDisplayUpdater) GetAppMediaId() (string, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiSystemMediaTransportControlsDisplayUpdater))
	defer itf.Release()
	v := (*iSystemMediaTransportControlsDisplayUpdater)(unsafe.Pointer(itf))
	return v.GetAppMediaId()
}

func (impl *SystemMediaTransportControlsDisplayUpdater) SetAppMediaId(value string) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiSystemMediaTransportControlsDisplayUpdater))
	defer itf.Release()
	v := (*iSystemMediaTransportControlsDisplayUpdater)(unsafe.Pointer(itf))
	return v.SetAppMediaId(value)
}

func (impl *SystemMediaTransportControlsDisplayUpdater) GetThumbnail() (*streams.RandomAccessStreamReference, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiSystemMediaTransportControlsDisplayUpdater))
	defer itf.Release()
	v := (*iSystemMediaTransportControlsDisplayUpdater)(unsafe.Pointer(itf))
	return v.GetThumbnail()
}

func (impl *SystemMediaTransportControlsDisplayUpdater) SetThumbnail(value *streams.RandomAccessStreamReference) error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiSystemMediaTransportControlsDisplayUpdater))
	defer itf.Release()
	v := (*iSystemMediaTransportControlsDisplayUpdater)(unsafe.Pointer(itf))
	return v.SetThumbnail(value)
}

func (impl *SystemMediaTransportControlsDisplayUpdater) GetMusicProperties() (*MusicDisplayProperties, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiSystemMediaTransportControlsDisplayUpdater))
	defer itf.Release()
	v := (*iSystemMediaTransportControlsDisplayUpdater)(unsafe.Pointer(itf))
	return v.GetMusicProperties()
}

func (impl *SystemMediaTransportControlsDisplayUpdater) GetVideoProperties() (*VideoDisplayProperties, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiSystemMediaTransportControlsDisplayUpdater))
	defer itf.Release()
	v := (*iSystemMediaTransportControlsDisplayUpdater)(unsafe.Pointer(itf))
	return v.GetVideoProperties()
}

func (impl *SystemMediaTransportControlsDisplayUpdater) GetImageProperties() (*ImageDisplayProperties, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiSystemMediaTransportControlsDisplayUpdater))
	defer itf.Release()
	v := (*iSystemMediaTransportControlsDisplayUpdater)(unsafe.Pointer(itf))
	return v.GetImageProperties()
}

func (impl *SystemMediaTransportControlsDisplayUpdater) CopyFromFileAsync(mType MediaPlaybackType, source *storage.StorageFile) (*foundation.IAsyncOperation, error) {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiSystemMediaTransportControlsDisplayUpdater))
	defer itf.Release()
	v := (*iSystemMediaTransportControlsDisplayUpdater)(unsafe.Pointer(itf))
	return v.CopyFromFileAsync(mType, source)
}

func (impl *SystemMediaTransportControlsDisplayUpdater) ClearAll() error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiSystemMediaTransportControlsDisplayUpdater))
	defer itf.Release()
	v := (*iSystemMediaTransportControlsDisplayUpdater)(unsafe.Pointer(itf))
	return v.ClearAll()
}

func (impl *SystemMediaTransportControlsDisplayUpdater) Update() error {
	itf := impl.MustQueryInterface(ole.NewGUID(GUIDiSystemMediaTransportControlsDisplayUpdater))
	defer itf.Release()
	v := (*iSystemMediaTransportControlsDisplayUpdater)(unsafe.Pointer(itf))
	return v.Update()
}

const GUIDiSystemMediaTransportControlsDisplayUpdater string = "8abbc53e-fa55-4ecf-ad8e-c984e5dd1550"
const SignatureiSystemMediaTransportControlsDisplayUpdater string = "{8abbc53e-fa55-4ecf-ad8e-c984e5dd1550}"

type iSystemMediaTransportControlsDisplayUpdater struct {
	ole.IInspectable
}

type iSystemMediaTransportControlsDisplayUpdaterVtbl struct {
	ole.IInspectableVtbl

	GetType            uintptr
	SetType            uintptr
	GetAppMediaId      uintptr
	SetAppMediaId      uintptr
	GetThumbnail       uintptr
	SetThumbnail       uintptr
	GetMusicProperties uintptr
	GetVideoProperties uintptr
	GetImageProperties uintptr
	CopyFromFileAsync  uintptr
	ClearAll           uintptr
	Update             uintptr
}

func (v *iSystemMediaTransportControlsDisplayUpdater) VTable() *iSystemMediaTransportControlsDisplayUpdaterVtbl {
	return (*iSystemMediaTransportControlsDisplayUpdaterVtbl)(unsafe.Pointer(v.RawVTable))
}

func (v *iSystemMediaTransportControlsDisplayUpdater) GetType() (MediaPlaybackType, error) {
	var out MediaPlaybackType
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetType,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out MediaPlaybackType
	)

	if hr != 0 {
		return MediaPlaybackTypeUnknown, ole.NewError(hr)
	}

	return out, nil
}

func (v *iSystemMediaTransportControlsDisplayUpdater) SetType(value MediaPlaybackType) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetType,
		uintptr(unsafe.Pointer(v)), // this
		uintptr(value),             // in MediaPlaybackType
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iSystemMediaTransportControlsDisplayUpdater) GetAppMediaId() (string, error) {
	var outHStr ole.HString
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetAppMediaId,
		uintptr(unsafe.Pointer(v)),        // this
		uintptr(unsafe.Pointer(&outHStr)), // out string
	)

	if hr != 0 {
		return "", ole.NewError(hr)
	}

	out := outHStr.String()
	ole.DeleteHString(outHStr)
	return out, nil
}

func (v *iSystemMediaTransportControlsDisplayUpdater) SetAppMediaId(value string) error {
	valueHStr, err := ole.NewHString(value)
	if err != nil {
		return err
	}
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetAppMediaId,
		uintptr(unsafe.Pointer(v)), // this
		uintptr(valueHStr),         // in string
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iSystemMediaTransportControlsDisplayUpdater) GetThumbnail() (*streams.RandomAccessStreamReference, error) {
	var out *streams.RandomAccessStreamReference
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetThumbnail,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out streams.RandomAccessStreamReference
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iSystemMediaTransportControlsDisplayUpdater) SetThumbnail(value *streams.RandomAccessStreamReference) error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().SetThumbnail,
		uintptr(unsafe.Pointer(v)),     // this
		uintptr(unsafe.Pointer(value)), // in streams.RandomAccessStreamReference
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iSystemMediaTransportControlsDisplayUpdater) GetMusicProperties() (*MusicDisplayProperties, error) {
	var out *MusicDisplayProperties
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetMusicProperties,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out MusicDisplayProperties
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iSystemMediaTransportControlsDisplayUpdater) GetVideoProperties() (*VideoDisplayProperties, error) {
	var out *VideoDisplayProperties
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetVideoProperties,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out VideoDisplayProperties
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iSystemMediaTransportControlsDisplayUpdater) GetImageProperties() (*ImageDisplayProperties, error) {
	var out *ImageDisplayProperties
	hr, _, _ := syscall.SyscallN(
		v.VTable().GetImageProperties,
		uintptr(unsafe.Pointer(v)),    // this
		uintptr(unsafe.Pointer(&out)), // out ImageDisplayProperties
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iSystemMediaTransportControlsDisplayUpdater) CopyFromFileAsync(mType MediaPlaybackType, source *storage.StorageFile) (*foundation.IAsyncOperation, error) {
	var out *foundation.IAsyncOperation
	hr, _, _ := syscall.SyscallN(
		v.VTable().CopyFromFileAsync,
		uintptr(unsafe.Pointer(v)),      // this
		uintptr(mType),                  // in MediaPlaybackType
		uintptr(unsafe.Pointer(source)), // in storage.StorageFile
		uintptr(unsafe.Pointer(&out)),   // out foundation.IAsyncOperation
	)

	if hr != 0 {
		return nil, ole.NewError(hr)
	}

	return out, nil
}

func (v *iSystemMediaTransportControlsDisplayUpdater) ClearAll() error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().ClearAll,
		uintptr(unsafe.Pointer(v)), // this
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}

func (v *iSystemMediaTransportControlsDisplayUpdater) Update() error {
	hr, _, _ := syscall.SyscallN(
		v.VTable().Update,
		uintptr(unsafe.Pointer(v)), // this
	)

	if hr != 0 {
		return ole.NewError(hr)
	}

	return nil
}
