// Code generated by winrt-go-gen. DO NOT EDIT.

//go:build windows

//nolint:all
package storage

import (
	"sync"
	"time"
	"unsafe"

	"github.com/go-ole/go-ole"
	"github.com/saltosystems/winrt-go/internal/delegate"
	"github.com/saltosystems/winrt-go/internal/kernel32"
)

const GUIDStreamedFileDataRequestedHandler string = "fef6a824-2fe1-4d07-a35b-b77c50b5f4cc"
const SignatureStreamedFileDataRequestedHandler string = "delegate({fef6a824-2fe1-4d07-a35b-b77c50b5f4cc})"

type StreamedFileDataRequestedHandler struct {
	ole.IUnknown
	sync.Mutex
	refs uint64
	IID  ole.GUID
}

type StreamedFileDataRequestedHandlerVtbl struct {
	ole.IUnknownVtbl
	Invoke uintptr
}

type StreamedFileDataRequestedHandlerCallback func(instance *StreamedFileDataRequestedHandler, stream *StreamedFileDataRequest)

var callbacksStreamedFileDataRequestedHandler = &streamedFileDataRequestedHandlerCallbacks{
	mu:        &sync.Mutex{},
	callbacks: make(map[unsafe.Pointer]StreamedFileDataRequestedHandlerCallback),
}

var releaseChannelsStreamedFileDataRequestedHandler = &streamedFileDataRequestedHandlerReleaseChannels{
	mu:    &sync.Mutex{},
	chans: make(map[unsafe.Pointer]chan struct{}),
}

func NewStreamedFileDataRequestedHandler(iid *ole.GUID, callback StreamedFileDataRequestedHandlerCallback) *StreamedFileDataRequestedHandler {
	// create type instance
	size := unsafe.Sizeof(*(*StreamedFileDataRequestedHandler)(nil))
	instPtr := kernel32.Malloc(size)
	inst := (*StreamedFileDataRequestedHandler)(instPtr)

	// get the callbacks for the VTable
	callbacks := delegate.RegisterCallbacks(instPtr, inst)

	// the VTable should also be allocated in the heap
	sizeVTable := unsafe.Sizeof(*(*StreamedFileDataRequestedHandlerVtbl)(nil))
	vTablePtr := kernel32.Malloc(sizeVTable)

	inst.RawVTable = (*interface{})(vTablePtr)

	vTable := (*StreamedFileDataRequestedHandlerVtbl)(vTablePtr)
	vTable.IUnknownVtbl = ole.IUnknownVtbl{
		QueryInterface: callbacks.QueryInterface,
		AddRef:         callbacks.AddRef,
		Release:        callbacks.Release,
	}
	vTable.Invoke = callbacks.Invoke

	// Initialize all properties: the malloc may contain garbage
	inst.IID = *iid // copy contents
	inst.Mutex = sync.Mutex{}
	inst.refs = 0

	callbacksStreamedFileDataRequestedHandler.add(unsafe.Pointer(inst), callback)

	// See the docs in the releaseChannelsStreamedFileDataRequestedHandler struct
	releaseChannelsStreamedFileDataRequestedHandler.acquire(unsafe.Pointer(inst))

	inst.addRef()
	return inst
}

func (r *StreamedFileDataRequestedHandler) GetIID() *ole.GUID {
	return &r.IID
}

// addRef increments the reference counter by one
func (r *StreamedFileDataRequestedHandler) addRef() uint64 {
	r.Lock()
	defer r.Unlock()
	r.refs++
	return r.refs
}

// removeRef decrements the reference counter by one. If it was already zero, it will just return zero.
func (r *StreamedFileDataRequestedHandler) removeRef() uint64 {
	r.Lock()
	defer r.Unlock()

	if r.refs > 0 {
		r.refs--
	}

	return r.refs
}

func (instance *StreamedFileDataRequestedHandler) Invoke(instancePtr, rawArgs0, rawArgs1, rawArgs2, rawArgs3, rawArgs4, rawArgs5, rawArgs6, rawArgs7, rawArgs8 unsafe.Pointer) uintptr {
	streamPtr := rawArgs0

	// See the quote above.
	stream := (*StreamedFileDataRequest)(streamPtr)
	if callback, ok := callbacksStreamedFileDataRequestedHandler.get(instancePtr); ok {
		callback(instance, stream)
	}
	return ole.S_OK
}

func (instance *StreamedFileDataRequestedHandler) AddRef() uint64 {
	return instance.addRef()
}

func (instance *StreamedFileDataRequestedHandler) Release() uint64 {
	rem := instance.removeRef()
	if rem == 0 {
		// We're done.
		instancePtr := unsafe.Pointer(instance)
		callbacksStreamedFileDataRequestedHandler.delete(instancePtr)

		// stop release channels used to avoid
		// https://github.com/golang/go/issues/55015
		releaseChannelsStreamedFileDataRequestedHandler.release(instancePtr)

		kernel32.Free(unsafe.Pointer(instance.RawVTable))
		kernel32.Free(instancePtr)
	}
	return rem
}

type streamedFileDataRequestedHandlerCallbacks struct {
	mu        *sync.Mutex
	callbacks map[unsafe.Pointer]StreamedFileDataRequestedHandlerCallback
}

func (m *streamedFileDataRequestedHandlerCallbacks) add(p unsafe.Pointer, v StreamedFileDataRequestedHandlerCallback) {
	m.mu.Lock()
	defer m.mu.Unlock()

	m.callbacks[p] = v
}

func (m *streamedFileDataRequestedHandlerCallbacks) get(p unsafe.Pointer) (StreamedFileDataRequestedHandlerCallback, bool) {
	m.mu.Lock()
	defer m.mu.Unlock()

	v, ok := m.callbacks[p]
	return v, ok
}

func (m *streamedFileDataRequestedHandlerCallbacks) delete(p unsafe.Pointer) {
	m.mu.Lock()
	defer m.mu.Unlock()

	delete(m.callbacks, p)
}

// typedEventHandlerReleaseChannels keeps a map with channels
// used to keep a goroutine alive during the lifecycle of this object.
// This is required to avoid causing a deadlock error.
// See this: https://github.com/golang/go/issues/55015
type streamedFileDataRequestedHandlerReleaseChannels struct {
	mu    *sync.Mutex
	chans map[unsafe.Pointer]chan struct{}
}

func (m *streamedFileDataRequestedHandlerReleaseChannels) acquire(p unsafe.Pointer) {
	m.mu.Lock()
	defer m.mu.Unlock()

	c := make(chan struct{})
	m.chans[p] = c

	go func() {
		// we need a timer to trick the go runtime into
		// thinking there's still something going on here
		// but we are only really interested in <-c
		t := time.NewTimer(time.Minute)
		for {
			select {
			case <-t.C:
				t.Reset(time.Minute)
			case <-c:
				t.Stop()
				return
			}
		}
	}()
}

func (m *streamedFileDataRequestedHandlerReleaseChannels) release(p unsafe.Pointer) {
	m.mu.Lock()
	defer m.mu.Unlock()

	if c, ok := m.chans[p]; ok {
		close(c)
		delete(m.chans, p)
	}
}
